"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCookiesStore = exports.CookiesStoreProviderCore = exports.CookiesStoreProvider = exports.CookiesStoreContext = void 0;
const react_1 = __importStar(require("react"));
const react_cookie_1 = require("react-cookie");
const universal_cookie_1 = __importDefault(require("universal-cookie"));
const debug_1 = __importDefault(require("debug"));
const store_1 = require("./store");
const debug = (0, debug_1.default)('store:cookie');
exports.CookiesStoreContext = (0, react_1.createContext)(store_1.defaultContext);
const CookiesStoreProvider = ({ context = exports.CookiesStoreContext, children, defaultCookies, options = {}, }) => {
    const [cookies] = (0, react_1.useState)(() => defaultCookies && new universal_cookie_1.default(defaultCookies));
    return react_1.default.createElement(react_cookie_1.CookiesProvider, { cookies: cookies },
        react_1.default.createElement(exports.CookiesStoreProviderCore, { options: options, context: context, defaultCookies: defaultCookies }, children));
};
exports.CookiesStoreProvider = CookiesStoreProvider;
const CookiesStoreProviderCore = ({ context = exports.CookiesStoreContext, children, defaultCookies = {}, options = {}, }) => {
    const [useStore] = (0, react_1.useState)(() => {
        return function useStore(key, defaultValue) {
            var _a;
            const memoDefaultValue = (0, react_1.useMemo)(() => defaultValue, []);
            const [cookie, setCookie, removeCookie] = (0, react_cookie_1.useCookies)([key]);
            const stateRef = (0, react_1.useRef)();
            stateRef.current = cookie === null || cookie === void 0 ? void 0 : cookie[key];
            const [setValue] = (0, react_1.useState)(() => (value) => {
                const _value = typeof (value) === 'function' ? value(stateRef.current) : value;
                debug('setValue', { key, defaultValue: memoDefaultValue, value: _value, options });
                return setCookie(key, { value: _value }, options);
            });
            const [unsetValue] = (0, react_1.useState)(() => () => {
                debug('unsetValue', { key, defaultValue: memoDefaultValue, options });
                return removeCookie(key, options);
            });
            let defaultCookie;
            try {
                defaultCookie = defaultCookies && defaultCookies[key] && typeof (defaultCookies[key]) === 'string' ? JSON.parse(defaultCookies[key]).value : defaultCookies[key];
            }
            catch (error) {
                debug('setStore:error', { error, key, defaultValue: memoDefaultValue, defaultCookie: defaultCookies[key] });
            }
            return [((cookie === null || cookie === void 0 ? void 0 : cookie[key]) && ((_a = cookie === null || cookie === void 0 ? void 0 : cookie[key]) === null || _a === void 0 ? void 0 : _a.value)) || (defaultCookies && defaultCookie) || memoDefaultValue, setValue, unsetValue];
        };
    });
    return react_1.default.createElement(context.Provider, { value: { useStore } }, children);
};
exports.CookiesStoreProviderCore = CookiesStoreProviderCore;
function useCookiesStore(key, defaultValue, context = exports.CookiesStoreContext) {
    return (0, store_1.useStore)(key, defaultValue, context);
}
exports.useCookiesStore = useCookiesStore;
//# sourceMappingURL=cookies.js.map